DROP PROCEDURE IF EXISTS sp_quickPurgeSession
GO

CREATE PROCEDURE sp_quickPurgeSession()
	COMMENT "utility procedure for quickPurgeSession.pl"
	LANGUAGE SQL
	MODIFIES SQL DATA

BEGIN
	
	SET @Depth = 1;

	SET @rowsold = 0;
	SET @rowsnew = 0;
	START TRANSACTION;
	SELECT COUNT(*) FROM tmp_del_object INTO @rowsold;

	loopX: WHILE @Depth < 10 DO

		INSERT INTO tmp_del_object
		SELECT o.objectid, @Depth
		FROM object o
		INNER JOIN tmp_del_object d_o ON o.parentid = d_o.objectid
			AND o.objectid NOT IN (SELECT objectid FROM tmp_del_object);

		SET @Depth = @Depth + 1;

		/* check for delta rows for early leave*/
		SELECT COUNT(*) FROM tmp_del_object INTO @rowsnew;

		IF @rowsnew = @rowsold then
			LEAVE loopX;
		END IF;
		SET @rowsold = @rowsnew;
		
	END WHILE;
	COMMIT;
	
END
GO

