use base qw(Test::Class);
use Test::More;
use DE_EPAGES::SDA::API::File::Record::SenderAddressBuilder;

use strict;

use constant CODE => '12345678901234567890';
use constant ADDRESS_BLANK =>
  '                                                                '
  . '                                                                                            ';
use constant COMPANY           => 'My Company Ltd.';
use constant COMPANY_BLANK     => '                         ';
use constant CONTACT           => 'My Contact';
use constant CONTACT_BLANK     => '          ';
use constant STREET_TYPE_BLANK => '     ';
use constant STREET            => 'Via Margutta';
use constant STREET_BLANK      => '                  ';
use constant NUMBER            => '123';
use constant NUMBER_BLANK      => '  ';
use constant PHONE             => '555-555555';
use constant PHONE_BLANK       => '     ';
use constant POSTCODE          => '63123';
use constant POSTCODE_BLANK    => '    ';
use constant TOWN              => 'Domodossola';
use constant TOWN_BLANK        => '                   ';
use constant PROVINCE          => 'Do';

sub address : Test(no_plan) {
    my %address = (
        'code'     => CODE,
        'person_or_company_name'  => COMPANY,
        'contact'  => CONTACT,
        'street'   => STREET . '  ' . NUMBER,
        'phone'    => PHONE,
        'postcode' => POSTCODE,
        'town'     => TOWN,
        'province' => PROVINCE,
    );
    my $builder =
      DE_EPAGES::SDA::API::File::Record::SenderAddressBuilder->new(%address);
    is(
        $builder->build(),
        CODE
          . COMPANY
          . COMPANY_BLANK
          . CONTACT
          . CONTACT_BLANK
          . STREET_TYPE_BLANK
          . STREET
          . STREET_BLANK
          . NUMBER
          . NUMBER_BLANK
          . PHONE
          . PHONE_BLANK
          . POSTCODE
          . POSTCODE_BLANK
          . TOWN
          . TOWN_BLANK
          . PROVINCE,
        'generated address fields'
    );
}

Test::Class->runtests;
