use strict;
use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::Database::API::Connection qw ( GetTestSite RunOnStore );
use Test::More;
use DE_EPAGES::Core::API::Error qw ( GetError ExistsError );
use DE_EPAGES::SDA::API::Config::InfoSDA;

sub Main {
    RunOnStore(
        'Store' => GetTestSite(),
        'Sub'   => sub {

            # tests
            my $Info = DE_EPAGES::SDA::API::Config::InfoSDA->getInfo();
            ok( defined $Info,         'SDA info retrieved' );
            ok( defined $Info->host(), 'ftp.sda.it' );
            eval { $Info->getInfo(); };
            if ( ExistsError() ) {
                my $Error = GetError();
                is( $Error->code, 'ILLEGAL_ACCESS',
                    'getInfo() must be called statically' )
                  or diag( $Error->longMessage );
            }
        }
    );
    done_testing;
    return;
}

RunScript( Sub => \&Main );

1;
