use strict;
use DE_EPAGES::Core::API::Script qw ( RunScript );
use Test::More;
use DE_EPAGES::SDA::API::File::Notification
  qw ( getNotificationInfos DELIVERY_IN_PROGRESS );

use constant EXP_TRANS_ID      => '4DDF9E06C0A80274983B';
use constant EXP_CONS_NOTE_NUM => '1120000000012';

sub Main {
    my ( $ShippingReferenceNumber, $consignmentNoteNumber, $status ) =
      getNotificationInfos('000001.txt');
    is( $ShippingReferenceNumber, EXP_TRANS_ID, 'ref number OK' );
    is( $consignmentNoteNumber, EXP_CONS_NOTE_NUM,
        'Consignment note number OK' );
    is( $status, DELIVERY_IN_PROGRESS, 'Status OK' );
    done_testing();
}

RunScript( Sub => \&Main );

1;
