use base qw(Test::Class);
use Test::More;
use DE_EPAGES::SDA::API::FTP::SDALogger;
use Test::MockObject;

use strict;
use DE_EPAGES::Core::API::Script qw( RunScript );

sub logging : Test(no_plan) {
    my $mock_logger = Test::MockObject->new();
    $mock_logger->mock( 'debug', sub { 'logging somewhere' } );
    my $sdaLogger = DE_EPAGES::SDA::API::FTP::SDALogger->new(
        'sub' => sub {
            ok( 1, 'logging wrapper OK' );
        },
        'logger' => $mock_logger
    );
    $sdaLogger->execute();
}

RunScript( Sub => sub { Test::Class->runtests; } );
