use base qw(Test::Class);
use Test::More;
use strict;
use DE_EPAGES::SDA::API::File::Record::StreetNumberBuilder;

use constant STREET_TYPE_BLANK => '     ';

sub address_one : Test(no_plan) {
    my $STREET       = 'Via Margutta';
    my $STREET_BLANK = '                  ';
    my $NUMBER       = '123 A';
    my $NUMBER_BLANK = '';

    _checkAddress( $STREET . ' ' . $NUMBER,
        $STREET . $STREET_BLANK . $NUMBER . $NUMBER_BLANK );
}

sub address_two : Test(no_plan) {
    my $STREET       = 'Via Margutta';
    my $STREET_BLANK = '                  ';
    my $NUMBER       = '123A';
    my $NUMBER_BLANK = ' ';
    _checkAddress( $STREET . ' ' . $NUMBER,
        $STREET . $STREET_BLANK . $NUMBER . $NUMBER_BLANK );
}

sub address_three : Test(no_plan) {
    my $STREET       = 'Via Margutta';
    my $STREET_BLANK = '                  ';
    my $NUMBER       = '123 ';
    my $NUMBER_BLANK = ' ';

    _checkAddress( $STREET . ' ' . $NUMBER,
        $STREET . $STREET_BLANK . $NUMBER . $NUMBER_BLANK );
}

sub address_four : Test(no_plan) {
    my $STREET       = 'Via 5 Maggio';
    my $STREET_BLANK = '                  ';
    my $NUMBER       = '123 ';
    my $NUMBER_BLANK = ' ';

    _checkAddress( $STREET . ' ' . $NUMBER,
        $STREET . $STREET_BLANK . $NUMBER . $NUMBER_BLANK );
}

sub address_five : Test(no_plan) {
    my $STREET       = 'Via 5 Maggio';
    my $STREET_BLANK = '                  ';
    my $NUMBER       = '12 C';
    my $NUMBER_BLANK = ' ';

    _checkAddress( $STREET . ' ' . $NUMBER,
        $STREET . $STREET_BLANK . $NUMBER . $NUMBER_BLANK );
}

sub address_six : Test(no_plan) {
    my $STREET       = 'Via Maggio';
    my $STREET_BLANK = '                    ';
    my $NUMBER       = '';
    my $NUMBER_BLANK = '     ';

    _checkAddress( $STREET . ' ' . $NUMBER,
        $STREET . $STREET_BLANK . $NUMBER . $NUMBER_BLANK );
}

sub address_seven : Test(no_plan) {
    my $STREET       = 'Via 5 Maggio';
    my $STREET_BLANK = '                  ';
    my $NUMBER       = '';
    my $NUMBER_BLANK = '     ';

    _checkAddress( $STREET . $NUMBER,
        $STREET . $STREET_BLANK . $NUMBER . $NUMBER_BLANK );
}

sub _checkAddress {
    my ( $streetAndNumber, $expected ) = @_;
    my $builder = DE_EPAGES::SDA::API::File::Record::StreetNumberBuilder->new(
        'street' => $streetAndNumber );
    is( $builder->build(), STREET_TYPE_BLANK . $expected, 'address checked' );
}
Test::Class->runtests;
