use base qw(Test::Class);
use Test::More;
use strict;
use DE_EPAGES::Core::API::Error qw ( GetError ExistsError );
use DE_EPAGES::SDA::API::File::Record::YesNoFieldBuilder;

sub checkYesValue : Test(no_plan) {
    my $value   = 'Y';
    my $builder = DE_EPAGES::SDA::API::File::Record::YesNoFieldBuilder->new(
        'value' => $value );
    isa_ok( $builder, 'DE_EPAGES::SDA::API::File::Record::YesNoFieldBuilder' );
    is( $builder->build(), 'Y', 'yes field created' );
}

sub checkNoValue : Test(no_plan) {
    my $value   = 'N';
    my $builder = DE_EPAGES::SDA::API::File::Record::YesNoFieldBuilder->new(
        'value' => $value );
    isa_ok( $builder, 'DE_EPAGES::SDA::API::File::Record::YesNoFieldBuilder' );
    is( $builder->build(), $value, 'no field created' );
}

sub invalidValue : Test(no_plan) {
    my $value = 'Error';
    eval {
        DE_EPAGES::SDA::API::File::Record::YesNoFieldBuilder->new(
            'value' => $value );
        fail('must throw an exception');
    };
    if ( ExistsError() ) {
        my $Error = GetError();
        is( $Error->code, 'UNDEF_VALUE', 'error on invalid value' )
          or diag( $Error->longMessage );
    }
}

Test::Class->runtests;
